Crypto++ 8.5 Free C++ class library of cryptographic schemes

Classes | Public Types | Public Member Functions | List of all members
Gunzip Class Reference

GZIP Decompression (RFC 1952) More...

Inheritance diagram for Gunzip:

## Classes
class | CrcErr
| Exception thrown when a CRC error occurs. More...
class | HeaderErr
| Exception thrown when a header decoding error occurs. More...
class | LengthErr
| Exception thrown when a length error occurs. More...
class | TailErr
| Exception thrown when the tail is too short. More...

## Public Types
typedef Inflator::Err | Err

## Public Member Functions
| Gunzip (BufferedTransformation *attachment=NULL, bool repeat=false, int autoSignalPropagation=-1)
| Construct a Gunzip decompressor. More...
word32 | GetFiletime () const
const std::string & | GetFilename (bool throwOnEncodingError=false) const
const std::string & | GetComment (bool throwOnEncodingError=false) const
Public Member Functions inherited from Inflator
| Inflator (BufferedTransformation *attachment=NULL, bool repeat=false, int autoSignalPropagation=-1)
| RFC 1951 Decompressor. More...
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing. More...
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation. More...
virtual unsigned int | GetLog2WindowSize () const
Public Member Functions inherited from AutoSignaling< Filter >
| AutoSignaling (int propagation=-1)
| Construct an AutoSignaling. More...
void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals. More...
int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
Public Member Functions inherited from Filter
| Filter (BufferedTransformation *attachment=NULL)
| Construct a Filter. More...
bool | Attachable ()
| Determine if attachable. More...
BufferedTransformation * | AttachedTransformation ()
| Retrieve attached transformation. More...
const BufferedTransformation * | AttachedTransformation () const
| Retrieve attached transformation. More...
void | Detach (BufferedTransformation *newAttachment=NULL)
| Replace an attached transformation. More...
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation. More...
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation. More...
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation. More...
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation. More...
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object. More...
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing. More...
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing. More...
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing. More...
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing. More...
size_t | PutWord64 (word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing. More...
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee. More...
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee. More...
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object. More...
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee. More...
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects. More...
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation. More...
virtual int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval. More...
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte. More...
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes. More...
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte. More...
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes. More...
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word. More...
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word. More...
size_t | GetWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 64-bit word. More...
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word. More...
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word. More...
size_t | PeekWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 64-bit word. More...
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input More...
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer. More...
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object to another BufferedTransformation. More...
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation. More...
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object. More...
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval. More...
virtual bool | GetNextMessage ()
| Start retrieving the next message. More...
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages. More...
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation. More...
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series. More...
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series. More...
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series. More...
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation. More...
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation. More...
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel. More...
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel. More...
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel. More...
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel. More...
size_t | ChannelPutWord64 (const std::string &channel, word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing on a channel. More...
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message. More...
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller. More...
virtual size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel. More...
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel. More...
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel. More...
virtual bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Marks the end of a series of messages on a channel. More...
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel. More...
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object. More...

## Detailed Description

GZIP Decompression (RFC 1952)

Definition at line 80 of file gzip.h.

## Constructor & Destructor Documentation

## ◆ Gunzip()

Gunzip::Gunzip | ( | BufferedTransformation * | attachment = `NULL`,
|  | bool | repeat = `false`,
|  | int | autoSignalPropagation = `-1`
| ) |  |

Construct a Gunzip decompressor.

Parameters

  attachment | an attached transformation
  repeat | decompress multiple compressed streams in series
  autoSignalPropagation | 0 to turn off MessageEnd signal

Definition at line 105 of file gzip.cpp.

## Member Function Documentation

## ◆ GetFiletime()

word32 Gunzip::GetFiletime | ( |  | ) | const
| inline

Returns
  the filetime of the stream as set in the header. The application is responsible for setting it on the decompressed file.

Definition at line 101 of file gzip.h.

## ◆ GetFilename()

const std::string & Gunzip::GetFilename | ( | bool | throwOnEncodingError = `false` | ) | const

Returns
  the filename of the stream as set in the header. The application is responsible for setting it on the decompressed file.

Parameters

  throwOnEncodingError | if throwOnEncodingError is true, then the filename is checked to ensure it is ISO/IEC 8859-1 encoded. If the filename does not adhere to ISO/IEC 8859-1, then a InvalidDataFormat is thrown. If throwOnEncodingError is false then the filename is not checked.

Definition at line 194 of file gzip.cpp.

## ◆ GetComment()

const std::string & Gunzip::GetComment | ( | bool | throwOnEncodingError = `false` | ) | const

Returns
  the comment of the stream as set in the header.

Parameters

  throwOnEncodingError | if throwOnEncodingError is true, then the comment is checked to ensure it is ISO/IEC 8859-1 encoded. If the comment does not adhere to ISO/IEC 8859-1, then a InvalidDataFormat is thrown. If throwOnEncodingError is false then the comment is not checked.

Definition at line 180 of file gzip.cpp.

The documentation for this class was generated from the following files:

- gzip.h
- gzip.cpp